Index: /palm/trunk/SOURCE/user_data_output_2d.f90
===================================================================
--- /palm/trunk/SOURCE/user_data_output_2d.f90	(revision 2231)
+++ /palm/trunk/SOURCE/user_data_output_2d.f90	(revision 2232)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Example code added for accessing output quantities stored on surface-data
+! types
 ! 
 ! Former revisions:
@@ -61,4 +62,6 @@
     USE kinds
 
+    USE surface_mod
+
     USE user
 
@@ -68,8 +71,9 @@
     CHARACTER (LEN=*) ::  variable !< 
 
-    INTEGER(iwp) ::  av !< 
-    INTEGER(iwp) ::  i  !< 
-    INTEGER(iwp) ::  j  !< 
-    INTEGER(iwp) ::  k  !< 
+    INTEGER(iwp) ::  av     !< flag to control data output of instantaneous or time-averaged data
+    INTEGER(iwp) ::  i      !< grid index along x-direction
+    INTEGER(iwp) ::  j      !< grid index along y-direction
+    INTEGER(iwp) ::  k      !< grid index along z-direction
+    INTEGER(iwp) ::  m      !< running index surface elements
     INTEGER(iwp) ::  nzb_do !< lower limit of the domain (usually nzb)
     INTEGER(iwp) ::  nzt_do !< upper limit of the domain (usually nzt+1)
@@ -110,4 +114,37 @@
 !
 !          grid = 'zu'
+!
+!--    In case two-dimensional surface variables are outputted, the user
+!--    has to access related surface-type. Uncomment and extend following lines
+!--    appropriately (example output of vertical surface momentum flux of u-
+!--    component). Please note, surface elements can be distributed over 
+!--    several data type, depending on their respective surface properties.
+!       CASE ( 'usws_xy' )
+!          IF ( av == 0 )  THEN
+!
+!--           Horizontal default-type surfaces
+!             DO  m = 1, surf_def_h(0)%ns
+!                i = surf_def_h(0)%i(m)
+!                j = surf_def_h(0)%j(m)
+!                local_pf(i,j,1) = surf_def_h(0)%usws(m)
+!             ENDDO
+!
+!--           Horizontal natural-type surfaces
+!             DO  m = 1, surf_lsm_h%ns
+!                i = surf_lsm_h%i(m)
+!                j = surf_lsm_h%j(m)
+!                local_pf(i,j,1) = surf_lsm_h%usws(m)
+!             ENDDO
+!
+!--           Horizontal urban-type surfaces
+!             DO  m = 1, surf_usm_h%ns
+!                i = surf_usm_h%i(m)
+!                j = surf_usm_h%j(m)
+!                local_pf(i,j,1) = surf_usm_h%usws(m)
+!             ENDDO
+!          ENDIF
+!
+!          grid = 'zu'
+!--       
 
 
Index: /palm/trunk/SOURCE/user_init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/user_init_3d_model.f90	(revision 2231)
+++ /palm/trunk/SOURCE/user_init_3d_model.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! +surface_mod
 ! 
 ! Former revisions:
@@ -58,4 +58,6 @@
     
     USE kinds
+
+    USE surface_mod
     
     USE user
Index: /palm/trunk/SOURCE/user_init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/user_init_grid.f90	(revision 2231)
+++ /palm/trunk/SOURCE/user_init_grid.f90	(revision 2232)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! +Generic tunnel added
+! +Example of setting user-defined topography
 ! 
 ! Former revisions:
@@ -55,5 +56,5 @@
 !> Execution of user-defined grid initializing actions
 !------------------------------------------------------------------------------!
- SUBROUTINE user_init_grid( nzb_local )
+ SUBROUTINE user_init_grid( topo_3d )
  
 
@@ -68,5 +69,8 @@
     IMPLICIT NONE
 
-    INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg) ::  nzb_local   !< 
+    INTEGER(iwp)                                           ::  k_topo      !< topography top index
+    INTEGER(iwp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  topo_3d     !< 3D topography field
+
+    REAL(wp) ::  h_topo !< user-defined topography height
 
 !
@@ -78,5 +82,5 @@
     SELECT CASE ( TRIM( topography ) )
 
-       CASE ( 'flat', 'single_building', 'single_street_canyon' )
+       CASE ( 'flat', 'single_building', 'single_street_canyon', 'tunnel' )
 !
 !--       Not allowed here since these are the standard cases used in init_grid.
@@ -88,4 +92,21 @@
           message_string = 'topography "' // topography // '" not available yet'
           CALL message( 'user_init_grid', 'UI0005', 1, 2, 0, 6, 0 )
+!
+!--       The user is allowed to set surface-mounted as well as non-surface
+!--       mounted topography (e.g. overhanging structures). For both, use 
+!--       3D array topo_3d and set bit 0. The convention is: bit is zero inside 
+!--       topography, bit is 1 for atmospheric grid point. 
+!--       The following example shows how to prescribe sine-like topography 
+!--       along x-direction with amplitude of 10 * dz and wavelength 10 * dy.
+!           DO  i = nxlg, nxrg
+!              h_topo = 10.0_wp * dz * (SIN(3.14_wp*0.5_wp)*i*dx / ( 5.0_wp * dy ) )**2
+! 
+!              k_topo = MINLOC( ABS( zw - h_topo ), 1 ) - 1
+! 
+!              topo_3d(k_topo+1:nzt+1,:,i) =                                     &
+!                                          IBSET( topo_3d(k_topo+1:nzt+1,:,i), 0 ) 
+!           ENDDO 
+! 
+!           CALL exchange_horiz_int( topo_3d, nbgp )
 
        CASE DEFAULT
@@ -100,4 +121,6 @@
 
 
+
+
  END SUBROUTINE user_init_grid
 
Index: /palm/trunk/SOURCE/user_init_land_surface.f90
===================================================================
--- /palm/trunk/SOURCE/user_init_land_surface.f90	(revision 2231)
+++ /palm/trunk/SOURCE/user_init_land_surface.f90	(revision 2232)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Load surface_mod
+! Add simple example how to access surface data type
 ! 
 ! Former revisions:
@@ -60,15 +61,21 @@
     
     USE pegrid
-    
+
+    USE surface_mod    
+
     USE user
 
     IMPLICIT NONE
 
-    INTEGER(iwp) :: i   !< running index
-    INTEGER(iwp) :: j   !< running index
+    INTEGER(iwp) ::  i  !< grid index
+    INTEGER(iwp) ::  j  !< grid index
+    INTEGER(iwp) ::  m  !< running index on 1D wall-type grid
 
 !
-!-- Here the user-defined land surface initialization actions follow:
-
+!-- Here the user-defined land surface initialization actions follow.
+!-- Example: set roughness length at natural land-surface
+!     DO  m = 1, surf_lsm_h%ns
+!        surf_lsm_h%z0(m) = 0.1_wp
+!     ENDDO
 
 
Index: /palm/trunk/SOURCE/user_init_urban_surface.f90
===================================================================
--- /palm/trunk/SOURCE/user_init_urban_surface.f90	(revision 2231)
+++ /palm/trunk/SOURCE/user_init_urban_surface.f90	(revision 2232)
@@ -21,5 +21,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Load surface_mod
+! Add simple example how to access surface data type
 ! 
 ! Former revisions:
@@ -50,4 +51,6 @@
 
     USE urban_surface_mod
+
+    USE surface_mod    
     
     USE user
@@ -55,9 +58,14 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i  !< running index
-    INTEGER(iwp) ::  j  !< running index
+    INTEGER(iwp) ::  i  !< grid index
+    INTEGER(iwp) ::  j  !< grid index
+    INTEGER(iwp) ::  m  !< running index on 1D wall-type grid
 
 !
-!-- Here the user-defined urban surface initialization actions follow:
+!-- Here the user-defined urban surface initialization actions follow.
+!-- Example: set roughness length at urban surface
+!     DO  m = 1, surf_usm_h%ns
+!        surf_usm_h%z0(m) = 0.1_wp
+!     ENDDO
 
 
Index: /palm/trunk/SOURCE/user_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/user_statistics.f90	(revision 2231)
+++ /palm/trunk/SOURCE/user_statistics.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Ajdustments for new topography masking
 ! 
 ! Former revisions:
@@ -111,12 +111,14 @@
 !       DO  i = nxl, nxr
 !          DO  j = nys, nyn
-!             DO  k = nzb_s_inner(j,i)+1, nzt
+!             DO  k = nzb+1, nzt
 !!
 !!--             Sample on how to calculate the profile of the resolved-scale
 !!--             horizontal momentum flux u*v*
-!                sums_l(k,pr_palm+1,tn) = sums_l(k,pr_palm+1,tn) +               &
-!                      ( 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ) - hom(k,1,1,sr) ) *     &
-!                      ( 0.5_wp * ( v(k,j,i) + v(k,j+1,i) ) - hom(k,1,2,sr) )       &
-!                                                 * rmask(j,i,sr)
+!                sums_l(k,pr_palm+1,tn) = sums_l(k,pr_palm+1,tn) +             &
+!                      ( 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ) - hom(k,1,1,sr) ) *&
+!                      ( 0.5_wp * ( v(k,j,i) + v(k,j+1,i) ) - hom(k,1,2,sr) )  &
+!                                     * rmask(j,i,sr)                          &
+!                                     * MERGE( 1.0_wp, 0.0_wp,                 &
+!                                              BTEST( wall_flags_0(k,j,i), 0 ) )
 !!
 !!--             Further profiles can be defined and calculated by increasing
Index: /palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography concept
 ! 
 ! Former revisions:
@@ -86,5 +86,5 @@
     USE indices,                                                               &
         ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nz,   &
-               nzb, nzb_u_inner, nzb_v_inner, nzb_w_inner, nzt
+               nzb, nzt, wall_flags_0
 
     USE kinds
@@ -1358,4 +1358,5 @@
        INTEGER(iwp) ::  ii, jj, kk       !<
     
+       REAL(wp)     ::  flag               !< flag to mask topography grid points
        REAL(wp)     ::  sin_rot, cos_rot   !<
        REAL(wp)     ::  sin_yaw, cos_yaw   !<
@@ -1971,8 +1972,13 @@
                 DO j = MAX( nys, j_hub(inot) - j_smear(inot) ),                &
                         MIN( nyn, j_hub(inot) + j_smear(inot) )
-                   DO k = MAX( nzb_u_inner(j,i)+1, k_hub(inot) - k_smear(inot) ), &
-                                k_hub(inot) + k_smear(inot)
+!                    DO k = MAX( nzb_u_inner(j,i)+1, k_hub(inot) - k_smear(inot) ), &
+!                                 k_hub(inot) + k_smear(inot)
+                   DO  k = nzb+1, k_hub(inot) + k_smear(inot)
                       DO ring = 1, nrings(inot)
                          DO rseg = 1, nsegs(ring,inot)
+!
+!--                         Predetermine flag to mask topography
+                            flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 1 ) )
+      
 !
 !--                         Determine the square of the distance between the
@@ -1995,20 +2001,23 @@
 !--                         squared distances <= eps_min2:
                             IF ( dist_u_3d <= eps_min2 ) THEN
-                            thrust(k,j,i) = thrust(k,j,i) +                    &
-                                            thrust_ring(ring,rseg) *           &
-                                            ( ( pol_a * dist_u_3d - pol_b ) *  & 
-                                             dist_u_3d + 1.0_wp ) * eps_factor
+                               thrust(k,j,i) = thrust(k,j,i) +                     &
+                                               thrust_ring(ring,rseg) *            &
+                                               ( ( pol_a * dist_u_3d - pol_b ) *   & 
+                                                dist_u_3d + 1.0_wp ) * eps_factor *&
+                                                                       flag
                             ENDIF
                             IF ( dist_v_3d <= eps_min2 ) THEN
-                            torque_y(k,j,i) = torque_y(k,j,i) +                &
-                                              torque_ring_y(ring,rseg) *       &
-                                              ( ( pol_a * dist_v_3d - pol_b ) *&
-                                               dist_v_3d + 1.0_wp ) * eps_factor
+                               torque_y(k,j,i) = torque_y(k,j,i) +                    &
+                                                 torque_ring_y(ring,rseg) *           &
+                                                 ( ( pol_a * dist_v_3d - pol_b ) *    &
+                                                  dist_v_3d + 1.0_wp ) * eps_factor * &
+                                                                         flag
                             ENDIF
                             IF ( dist_w_3d <= eps_min2 ) THEN
-                            torque_z(k,j,i) = torque_z(k,j,i) +                &
-                                              torque_ring_z(ring,rseg) *       &
-                                              ( ( pol_a * dist_w_3d - pol_b ) *&
-                                               dist_w_3d + 1.0_wp ) * eps_factor
+                               torque_z(k,j,i) = torque_z(k,j,i) +                    &
+                                                 torque_ring_z(ring,rseg) *           &
+                                                 ( ( pol_a * dist_w_3d - pol_b ) *    &
+                                                  dist_w_3d + 1.0_wp ) * eps_factor * &
+                                                                         flag
                             ENDIF
 
@@ -2018,18 +2027,21 @@
 !
 !--                   Rotation of force components:
-                      rot_tend_x(k,j,i) = rot_tend_x(k,j,i) +                  &
+                      rot_tend_x(k,j,i) = rot_tend_x(k,j,i) + (                &
                                       thrust(k,j,i)*rotx(inot,1) +             &
                                       torque_y(k,j,i)*roty(inot,1) +           &
-                                      torque_z(k,j,i)*rotz(inot,1)
+                                      torque_z(k,j,i)*rotz(inot,1)             &
+                                                              ) * flag
                                 
-                      rot_tend_y(k,j,i) = rot_tend_y(k,j,i) +                  &
+                      rot_tend_y(k,j,i) = rot_tend_y(k,j,i) + (                &
                                       thrust(k,j,i)*rotx(inot,2) +             &
                                       torque_y(k,j,i)*roty(inot,2) +           &
-                                      torque_z(k,j,i)*rotz(inot,2)
+                                      torque_z(k,j,i)*rotz(inot,2)             &
+                                                              ) * flag
                                 
-                      rot_tend_z(k,j,i) = rot_tend_z(k,j,i) +                  &
+                      rot_tend_z(k,j,i) = rot_tend_z(k,j,i) + (                &
                                       thrust(k,j,i)*rotx(inot,3) +             &
                                       torque_y(k,j,i)*roty(inot,3) +           &
-                                      torque_z(k,j,i)*rotz(inot,3)                               
+                                      torque_z(k,j,i)*rotz(inot,3)             &
+                                                              ) * flag                    
 
                    ENDDO        ! End of loop over k
@@ -2424,5 +2436,5 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   DO  k = nzb_u_inner(j,i)+1, k_hub(1) + k_smear(1)
+                   DO  k = nzb+1, k_hub(1) + k_smear(1)
 !
 !--                   Calculate the thrust generated by the nacelle and the tower
@@ -2432,6 +2444,8 @@
                                          SIGN( u(k,j,i)**2 , u(k,j,i) ) 
                                                    
-                      tend(k,j,i) = tend(k,j,i) - rot_tend_x(k,j,i)            &
-                                  - tend_nac_x - tend_tow_x
+                      tend(k,j,i) = tend(k,j,i) + ( - rot_tend_x(k,j,i)        &
+                                  - tend_nac_x - tend_tow_x )                  &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
                    ENDDO
                 ENDDO
@@ -2445,11 +2459,13 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   DO  k = nzb_v_inner(j,i)+1, k_hub(1) + k_smear(1)
+                   DO  k = nzb+1, k_hub(1) + k_smear(1)
                       tend_nac_y = 0.5_wp * nac_cd_surf(k,j,i) *               &
                                          SIGN( v(k,j,i)**2 , v(k,j,i) )     
                       tend_tow_y   = 0.5_wp * tow_cd_surf(k,j,i) *             &
                                          SIGN( v(k,j,i)**2 , v(k,j,i) )                      
-                      tend(k,j,i) = tend(k,j,i) - rot_tend_y(k,j,i)            &
-                                  - tend_nac_y - tend_tow_y
+                      tend(k,j,i) = tend(k,j,i) + ( - rot_tend_y(k,j,i)        &
+                                  - tend_nac_y - tend_tow_y )                  &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
                    ENDDO
                 ENDDO
@@ -2463,6 +2479,8 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   DO  k = nzb_w_inner(j,i)+1,  k_hub(1) + k_smear(1)
-                      tend(k,j,i) = tend(k,j,i) - rot_tend_z(k,j,i)
+                   DO  k = nzb+1,  k_hub(1) + k_smear(1)
+                      tend(k,j,i) = tend(k,j,i) - rot_tend_z(k,j,i)            &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 3 ) )
                    ENDDO
                 ENDDO
@@ -2506,5 +2524,5 @@
           IF ( simulated_time >= time_turbine_on )  THEN
 
-             DO  k = nzb_u_inner(j,i)+1,  k_hub(1) + k_smear(1)
+             DO  k = nzb+1,  k_hub(1) + k_smear(1)
 !
 !--             Calculate the thrust generated by the nacelle and the tower 
@@ -2513,6 +2531,8 @@
                 tend_tow_x   = 0.5_wp * tow_cd_surf(k,j,i) *                   &
                                    SIGN( u(k,j,i)**2 , u(k,j,i) ) 
-                tend(k,j,i) = tend(k,j,i) - rot_tend_x(k,j,i)                  &
-                            - tend_nac_x - tend_tow_x
+                tend(k,j,i) = tend(k,j,i) + ( - rot_tend_x(k,j,i)              &
+                            - tend_nac_x - tend_tow_x )                        &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 1 ) )
              ENDDO
           ENDIF
@@ -2522,11 +2542,13 @@
 !--       Apply the y-component of the force to the v-component of the flow:
           IF ( simulated_time >= time_turbine_on )  THEN
-             DO  k = nzb_v_inner(j,i)+1,  k_hub(1) + k_smear(1)
+             DO  k = nzb+1,  k_hub(1) + k_smear(1)
                 tend_nac_y = 0.5_wp * nac_cd_surf(k,j,i) *                     &
                                    SIGN( v(k,j,i)**2 , v(k,j,i) )     
                 tend_tow_y   = 0.5_wp * tow_cd_surf(k,j,i) *                   &
                                    SIGN( v(k,j,i)**2 , v(k,j,i) )                      
-                tend(k,j,i) = tend(k,j,i) - rot_tend_y(k,j,i)                  &
-                            - tend_nac_y - tend_tow_y
+                tend(k,j,i) = tend(k,j,i) + ( - rot_tend_y(k,j,i)              &
+                            - tend_nac_y - tend_tow_y )                        &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 2 ) )
              ENDDO
           ENDIF
@@ -2536,6 +2558,8 @@
 !--       Apply the z-component of the force to the w-component of the flow:
           IF ( simulated_time >= time_turbine_on )  THEN
-             DO  k = nzb_w_inner(j,i)+1,  k_hub(1) + k_smear(1)
-                tend(k,j,i) = tend(k,j,i) - rot_tend_z(k,j,i)
+             DO  k = nzb+1,  k_hub(1) + k_smear(1)
+                tend(k,j,i) = tend(k,j,i) - rot_tend_z(k,j,i)                  &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 3 ) )
              ENDDO
           ENDIF
Index: /palm/trunk/SOURCE/write_3d_binary.f90
===================================================================
--- /palm/trunk/SOURCE/write_3d_binary.f90	(revision 2231)
+++ /palm/trunk/SOURCE/write_3d_binary.f90	(revision 2232)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new surface concept - move output of surface varariables
+! to surface_mod
 ! 
 ! Former revisions:
@@ -112,10 +113,7 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  e, kh, km, ol, p, pt, q, ql, qc, nr, nrs, nrsws, nrswst,        &
-               prr, precipitation_amount, qr,                                  &
-               qrs, qrsws, qrswst, qs, qsws, qswst, s, sa, ssws, sswst,        &
-               saswsb, saswst, rif_wall, shf, ss, ts, tswst, u, u_m_l, u_m_n,  &
-               u_m_r, u_m_s, us, usws, uswst, v, v_m_l, v_m_n, v_m_r, v_m_s,   &
-               vpt, vsws, vswst, w, w_m_l, w_m_n, w_m_r, w_m_s, z0, z0h, z0q
+        ONLY:  e, kh, km, p, pt, q, ql, qc, nr, prr, precipitation_amount, qr, &
+               s, sa, u, u_m_l, u_m_n, u_m_r, u_m_s, v, v_m_l, v_m_n, v_m_r,   &
+               v_m_s, vpt, w, w_m_l, w_m_n, w_m_r, w_m_s
         
     USE averaging
@@ -142,8 +140,11 @@
         ONLY:  spectrum_x, spectrum_y
 
+    USE surface_mod,                                                           &
+        ONLY :  surface_write_restart_data
+
+
     IMPLICIT NONE
 
     CHARACTER (LEN=10) ::  binary_version   !< 
-
 
 !
@@ -164,5 +165,4 @@
 !--            Also, the list of arrays to be read in read_3d_binary must be
 !--            adjusted accordingly.
-
     WRITE ( 14 )  'e                   ';  WRITE ( 14 )  e
     IF ( ALLOCATED( e_av ) )  THEN
@@ -178,5 +178,4 @@
        WRITE ( 14 )  'lwp_av              ';  WRITE ( 14 )  lwp_av
     ENDIF
-    WRITE ( 14 )  'ol                  ';  WRITE ( 14 )  ol
     WRITE ( 14 )  'p                   ';  WRITE ( 14 )  p
     IF ( ALLOCATED( p_av ) )  THEN
@@ -226,23 +225,14 @@
                    WRITE ( 14 )  'nr_av               ';  WRITE ( 14 )  nr_av
                 ENDIF
-                WRITE ( 14 )  'nrs                 ';  WRITE ( 14 )  nrs
-                WRITE ( 14 )  'nrsws               ';  WRITE ( 14 )  nrsws
-                WRITE ( 14 )  'nrswst              ';  WRITE ( 14 )  nrswst
                 WRITE ( 14 )  'qr                  ';  WRITE ( 14 )  qr
                 IF ( ALLOCATED( qr_av ) )  THEN
                    WRITE ( 14 )  'qr_av               ';  WRITE ( 14 )  qr_av
                 ENDIF
-                WRITE ( 14 )  'qrs                 ';  WRITE ( 14 )  qrs
-                WRITE ( 14 )  'qrsws               ';  WRITE ( 14 )  qrsws
-                WRITE ( 14 )  'qrswst              ';  WRITE ( 14 )  qrswst
              ENDIF
           ENDIF
        ENDIF
-       WRITE ( 14 )  'qs                  ';  WRITE ( 14 )  qs
-       WRITE ( 14 )  'qsws                ';  WRITE ( 14 )  qsws
        IF ( ALLOCATED( qsws_av ) )  THEN
           WRITE ( 14 )  'qsws_av             ';  WRITE ( 14 )  qsws_av
        ENDIF
-       WRITE ( 14 )  'qswst               ';  WRITE ( 14 ) qswst
     ENDIF
     IF ( passive_scalar )  THEN
@@ -251,10 +241,7 @@
           WRITE ( 14 )  's_av                ';  WRITE ( 14 )  s_av
        ENDIF
-       WRITE ( 14 )  'ss                  ';  WRITE ( 14 )  ss
-       WRITE ( 14 )  'ssws                ';  WRITE ( 14 )  ssws
        IF ( ALLOCATED( ssws_av ) )  THEN
           WRITE ( 14 )  'ssws_av             ';  WRITE ( 14 )  ssws_av
        ENDIF
-       WRITE ( 14 )  'sswst               ';  WRITE ( 14 ) sswst
     ENDIF    
     IF ( ocean )  THEN
@@ -266,6 +253,4 @@
           WRITE ( 14 )  'sa_av               ';  WRITE ( 14 )  sa_av
        ENDIF
-       WRITE ( 14 )  'saswsb              ';  WRITE ( 14 )  saswsb
-       WRITE ( 14 )  'saswst              ';  WRITE ( 14 )  saswst
     ENDIF
     IF ( ALLOCATED( ql_c_av ) )  THEN
@@ -287,11 +272,7 @@
                                            WRITE ( 14 )  seq_random_array
     ENDIF
-    IF ( topography /= 'flat' )  THEN
-       WRITE ( 14 )  'rif_wall            ';  WRITE ( 14 )  rif_wall
-    ENDIF
     IF ( ALLOCATED( s_av ) )  THEN
        WRITE ( 14 )  's_av                ';  WRITE ( 14 )  s_av
     ENDIF
-    WRITE ( 14 )  'shf                 ';  WRITE ( 14 )  shf
     IF ( ALLOCATED( shf_av ) )  THEN
        WRITE ( 14 )  'shf_av              ';  WRITE ( 14 )  shf_av
@@ -301,9 +282,7 @@
        WRITE ( 14 )  'spectrum_y          ';  WRITE ( 14 )  spectrum_y
     ENDIF
-    WRITE ( 14 )  'ts                  ';  WRITE ( 14 )  ts
     IF ( ALLOCATED( ts_av ) )  THEN
        WRITE ( 14 )  'ts_av               ';  WRITE ( 14 )  ts_av
     ENDIF
-    WRITE ( 14 )  'tswst               ';  WRITE ( 14 )  tswst
     WRITE ( 14 )  'u                   ';  WRITE ( 14 )  u
     IF ( ALLOCATED( u_av ) )  THEN
@@ -322,7 +301,4 @@
        WRITE ( 14 )  'u_m_s               ';  WRITE ( 14 )  u_m_s
     ENDIF
-    WRITE ( 14 )  'us                  ';  WRITE ( 14 )  us
-    WRITE ( 14 )  'usws                ';  WRITE ( 14 )  usws
-    WRITE ( 14 )  'uswst               ';  WRITE ( 14 )  uswst
     IF ( ALLOCATED( us_av ) )  THEN
        WRITE ( 14 )  'us_av               ';  WRITE ( 14 )  us_av
@@ -350,6 +326,4 @@
        ENDIF
     ENDIF
-    WRITE ( 14 )  'vsws                ';  WRITE ( 14 )  vsws
-    WRITE ( 14 )  'vswst               ';  WRITE ( 14 )  vswst
     WRITE ( 14 )  'w                   ';  WRITE ( 14 )  w
     IF ( ALLOCATED( w_av ) )  THEN
@@ -368,13 +342,10 @@
        WRITE ( 14 )  'w_m_s               ';  WRITE ( 14 )  w_m_s
     ENDIF
-    WRITE ( 14 )  'z0                  ';  WRITE ( 14 )  z0
     IF ( ALLOCATED( z0_av ) )  THEN
        WRITE ( 14 )  'z0_av               ';  WRITE ( 14 )  z0_av
     ENDIF
-    WRITE ( 14 )  'z0h                 ';  WRITE ( 14 )  z0h
     IF ( ALLOCATED( z0h_av ) )  THEN
        WRITE ( 14 )  'z0h_av              ';  WRITE ( 14 )  z0h_av
     ENDIF
-    WRITE ( 14 )  'z0q                 ';  WRITE ( 14 )  z0q
     IF ( ALLOCATED( z0q_av ) )  THEN
        WRITE ( 14 )  'z0q_av              ';  WRITE ( 14 )  z0q_av
@@ -385,4 +356,6 @@
     WRITE ( 14 )  '*** end ***         '
 
+    CALL surface_write_restart_data
+
  END SUBROUTINE write_3d_binary
  
Index: /palm/trunk/SOURCE/write_var_list.f90
===================================================================
--- /palm/trunk/SOURCE/write_var_list.f90	(revision 2231)
+++ /palm/trunk/SOURCE/write_var_list.f90	(revision 2232)
@@ -20,5 +20,8 @@
 ! Current revisions:
 ! -----------------
-! 
+! Replace wall_qflux, wall_sflux by wall_humidityflux and wall_scalarflux; add
+! wall_salinityflux
+! +tunnel_height, tunnel_lenth, tunnel_width_x, tunnel_width_y, 
+! tunnel_wall_depth
 ! 
 ! Former revisions:
@@ -614,4 +617,14 @@
     WRITE ( 14 )  'tsc                           '
     WRITE ( 14 )  tsc
+    WRITE ( 14 )  'tunnel_height                 '
+    WRITE ( 14 )  tunnel_height
+    WRITE ( 14 )  'tunnel_length                 '
+    WRITE ( 14 )  tunnel_length
+    WRITE ( 14 )  'tunnel_width_x                '
+    WRITE ( 14 )  tunnel_width_x
+    WRITE ( 14 )  'tunnel_width_y                '
+    WRITE ( 14 )  tunnel_width_y
+    WRITE ( 14 )  'tunnel_wall_depth             '
+    WRITE ( 14 )  tunnel_wall_depth
     WRITE ( 14 )  'collision_turbulence          '
     WRITE ( 14 )  collision_turbulence
@@ -680,8 +693,10 @@
     WRITE ( 14 )  'wall_heatflux                 '
     WRITE ( 14 )  wall_heatflux
-    WRITE ( 14 )  'wall_qflux                    '
-    WRITE ( 14 )  wall_qflux
-    WRITE ( 14 )  'wall_sflux                    '
-    WRITE ( 14 )  wall_sflux
+    WRITE ( 14 )  'wall_humidityflux             '
+    WRITE ( 14 )  wall_humidityflux
+    WRITE ( 14 )  'wall_scalarflux               '
+    WRITE ( 14 )  wall_scalarflux
+    WRITE ( 14 )  'wall_salinityflux             '
+    WRITE ( 14 )  wall_salinityflux
     WRITE ( 14 )  'w_max                         '
     WRITE ( 14 )  w_max
@@ -694,4 +709,5 @@
     WRITE ( 14 )  'z0h_factor                    '
     WRITE ( 14 )  z0h_factor  
+
 !
 !-- Set the end-of-file mark
